'use strict';

// { opacity: [0.5, 1] } 
// => [ { offset: 1, keyframes: {opacity: 0.5} , { offset: 1, keyframes: {opacity: 1} ]
// { opacity: [0.5, 0, 1] } 
// => [ { offset: 1, keyframes: {opacity: 0.5} , { offset: 0.5, keyframes: {opacity: 0}, { offset: 1, keyframes: {opacity: 1} ]

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parseValues = function parseValues(propertyName, keyframeValues) {
  return keyframeValues.map(function (value, index, arr) {
    return {
      offset: index / (arr.length - 1), // calcurate offset
      keyframe: (0, _defineProperty3.default)({}, propertyName, value)
    };
  });
};

// Flatten and Convert object
var parseObject = function parseObject(keyframes) {
  return (0, _keys2.default)(keyframes).map(function (key) {
    return [key, keyframes[key]];
  }) // Object.entries
  .filter(function (_ref) {
    var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

    var k = _ref2[0];
    var v = _ref2[1];
    return Array.isArray(v);
  }) // filter non array value
  .map(function (_ref3) {
    var _ref4 = (0, _slicedToArray3.default)(_ref3, 2);

    var key = _ref4[0];
    var value = _ref4[1];
    return parseValues(key, value);
  }).reduce(function (prev, next) {
    return [].concat((0, _toConsumableArray3.default)(prev), (0, _toConsumableArray3.default)(next));
  }, []); // flatten
};

var uniqueOffset = function uniqueOffset(values) {
  return values.map(function (kf) {
    return kf.offset;
  }).filter(function (elm, i, arr) {
    return arr.indexOf(elm) === i;
  });
};

var reduceCurrentKeyframe = function reduceCurrentKeyframe(values, offset) {
  return values.filter(function (v) {
    return v.offset == offset;
  }).map(function (v) {
    return v.keyframe;
  }).reduce(function (prev, kf) {
    return (0, _assign2.default)(prev, kf);
  }, {});
};

var groupByOffset = function groupByOffset(values) {
  return uniqueOffset(values).map(function (offset) {
    var keyframes = reduceCurrentKeyframe(values, offset);
    return (0, _assign2.default)({ offset: offset }, keyframes);
  });
};

module.exports = function (keyframes) {
  var values = parseObject(keyframes);
  return groupByOffset(values);
};